/**
 * Copyright 2012 Bryan Miller
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package lib.obsidianblk.midnightgdx;

import lib.obsidianblk.midnightgdx.exceptions.MeshException;

import com.badlogic.gdx.utils.Disposable;


public abstract class Mesh implements Disposable{

	public abstract boolean strictExceptions();
	public abstract boolean strictExceptions(boolean strict);
	
	public abstract int vertexCount();
	public abstract boolean containsAttributes(int a);
	public abstract int getAttributes();
	public abstract int texureDepth();
	
	public abstract void finalize();
	public abstract boolean finalized();
	
	public abstract void setIndicies(short[] src, int offset) throws MeshException;
	public abstract void setIndex(int index, short val) throws MeshException;
	
	public abstract void setVerticies(float[] src, int offset) throws MeshException;
	public abstract void setVertexPosition(float[] pos, int offset) throws MeshException;
	public abstract void setVertexColor(float[] color, int offset) throws MeshException;
	public abstract void setVertexNormal(float[] norm, int offset) throws MeshException;
	public abstract void setVertexTexCoord(float[] texCoord, int offset) throws MeshException;
	
	public abstract void bind();
	public abstract void unbind();
	public abstract void render(int glShape) throws MeshException;
}
