package lib.obsidianblk.midnightgdx;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

import com.badlogic.gdx.assets.AssetDescriptor;
import com.badlogic.gdx.assets.AssetLoaderParameters;
import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.assets.loaders.AsynchronousAssetLoader;
import com.badlogic.gdx.assets.loaders.FileHandleResolver;
import com.badlogic.gdx.utils.Array;


public class ModelLoader extends AsynchronousAssetLoader<Model, ModelLoader.ModelParameter>{
	Model model;
	
	public ModelLoader (FileHandleResolver resolver) {
		super(resolver);
	}
	
	@Override
	public void loadAsync(AssetManager manager, String fileName, ModelParameter parameter) throws IllegalArgumentException{
		if (parameter == null || (parameter != null && parameter.ModelTypeClass == null)){
			throw new IllegalArgumentException("No Model type class given");
		}
		if (!parameter.ModelTypeClass.isAssignableFrom(Model.class)){
			throw new IllegalArgumentException("Class given is not a valid model type class.");
		}
		Constructor<Model> mcon;
		try {
			mcon = parameter.ModelTypeClass.getConstructor();
			model = mcon.newInstance();
		} catch (SecurityException e) {
			model = null;
		} catch (NoSuchMethodException e) {
			model = null;
		} catch (InstantiationException e) {
			model = null;
		} catch (IllegalAccessException e) {
			model = null;
		} catch (InvocationTargetException e) {
			model = null;
		}
		
		if (model != null){
			//model.loadModel();
		}
	}
	@Override
	public Model loadSync(AssetManager manager, String fileName, ModelParameter parameter) {
		// TODO Auto-generated method stub
		return null;
	}
	@Override
	public Array<AssetDescriptor> getDependencies(String fileName,
			ModelParameter parameter) {
		// TODO Auto-generated method stub
		return null;
	}
	
	static public class ModelParameter extends AssetLoaderParameters<Model> {
		// TODO:
		// Will this force only the Model class to be given or can I pass in classes derived from the Model class...
		Class<Model> ModelTypeClass;
	}
}
